Index: branches/v5/platforms/tsar_generic_xbar/tsar_xbar_cluster/caba/source/include/tsar_xbar_cluster.h
===================================================================
--- trunk/platforms/tsar_generic_xbar/tsar_xbar_cluster/caba/source/include/tsar_xbar_cluster.h	(revision 437)
+++ branches/v5/platforms/tsar_generic_xbar/tsar_xbar_cluster/caba/source/include/tsar_xbar_cluster.h	(revision 447)
@@ -69,4 +69,6 @@
     DspinSignals<dspin_cmd_width>   signal_dspin_m2p_l2g_c;
     DspinSignals<dspin_cmd_width>   signal_dspin_m2p_g2l_c;
+    DspinSignals<dspin_cmd_width>   signal_dspin_clack_l2g_c;
+    DspinSignals<dspin_cmd_width>   signal_dspin_clack_g2l_c;
     DspinSignals<dspin_rsp_width>   signal_dspin_rsp_l2g_d;
     DspinSignals<dspin_rsp_width>   signal_dspin_rsp_g2l_d;
@@ -115,6 +117,8 @@
     // Coherence DSPIN signals to local crossbar
     DspinSignals<dspin_cmd_width>     signal_dspin_m2p_memc;
+    DspinSignals<dspin_cmd_width>     signal_dspin_clack_memc;
     DspinSignals<dspin_rsp_width>     signal_dspin_p2m_memc;
     DspinSignals<dspin_cmd_width>     signal_dspin_m2p_proc[8];
+    DspinSignals<dspin_cmd_width>     signal_dspin_clack_proc[8];
     DspinSignals<dspin_rsp_width>     signal_dspin_p2m_proc[8];
 
@@ -198,4 +202,5 @@
     DspinLocalCrossbar<dspin_cmd_width>*          xbar_m2p_c;
     DspinLocalCrossbar<dspin_rsp_width>*          xbar_p2m_c;
+    DspinLocalCrossbar<dspin_cmd_width>*          xbar_clack_c;
 
     VirtualDspinRouter<dspin_cmd_width>*          router_cmd;
Index: branches/v5/platforms/tsar_generic_xbar/tsar_xbar_cluster/caba/source/src/tsar_xbar_cluster.cpp
===================================================================
--- trunk/platforms/tsar_generic_xbar/tsar_xbar_cluster/caba/source/src/tsar_xbar_cluster.cpp	(revision 437)
+++ branches/v5/platforms/tsar_generic_xbar/tsar_xbar_cluster/caba/source/src/tsar_xbar_cluster.cpp	(revision 447)
@@ -148,4 +148,5 @@
                      8,                                  // TRANSACTION TABLE DEPTH
                      8,                                  // UPDATE TABLE DEPTH
+                     8,                                  // INVALIDATE TABLE DEPTH
                      debug_start_cycle,
                      memc_debug_ok );
@@ -267,4 +268,17 @@
                      false,                        // don't use local routing table
                      false );                      // no broadcast 
+
+    /////////////////////////////////////////////////////////////////////////////
+    xbar_clack_c = new DspinLocalCrossbar<dspin_cmd_width>(
+                     "xbar_clack_c",
+                     mtd,                          // mapping table
+                     x_id, y_id,                   // cluster coordinates
+                     x_width, y_width, l_width,
+                     1,                            // number of local sources
+                     nb_procs,                     // number of local targets 
+                     1, 1,                         // fifo depths
+                     true,                         // CMD
+                     false,                        // don't use local routing table
+                     false);                       // broadcast
 
     /////////////////////////////////////////////////////////////////////////////
@@ -470,4 +484,15 @@
     std::cout << "  - M2P Coherence crossbar connected" << std::endl;
 
+    ////////////////////// CLACK DSPIN local crossbar coherence
+    xbar_clack_c->p_clk                          (this->p_clk);
+    xbar_clack_c->p_resetn                       (this->p_resetn);
+    xbar_clack_c->p_global_out                   (signal_dspin_clack_l2g_c);
+    xbar_clack_c->p_global_in                    (signal_dspin_clack_g2l_c);
+    xbar_clack_c->p_local_in[0]                  (signal_dspin_clack_memc);
+    for (size_t p = 0; p < nb_procs; p++)
+        xbar_clack_c->p_local_out[p]               (signal_dspin_clack_proc[p]);
+
+    std::cout << "  - Clack Coherence crossbar connected" << std::endl;
+
     ////////////////////////// P2M DSPIN local crossbar coherence
     xbar_p2m_c->p_clk                            (this->p_clk);
@@ -488,6 +513,7 @@
         proc[p]->p_resetn                   (this->p_resetn);
         proc[p]->p_vci                      (signal_vci_ini_proc[p]);
-        proc[p]->p_dspin_in                 (signal_dspin_m2p_proc[p]);
-        proc[p]->p_dspin_out                (signal_dspin_p2m_proc[p]);
+        proc[p]->p_dspin_m2p                (signal_dspin_m2p_proc[p]);
+        proc[p]->p_dspin_p2m                (signal_dspin_p2m_proc[p]);
+        proc[p]->p_dspin_clack              (signal_dspin_clack_proc[p]);
         proc[p]->p_irq[0]                   (signal_proc_it[p]);
         for ( size_t j = 1 ; j < 6 ; j++)
@@ -546,6 +572,7 @@
     memc->p_vci_ixr                    (signal_vci_xram);
     memc->p_vci_tgt                    (signal_vci_tgt_memc);
-    memc->p_dspin_in                   (signal_dspin_p2m_memc);
-    memc->p_dspin_out                  (signal_dspin_m2p_memc);
+    memc->p_dspin_p2m                  (signal_dspin_p2m_memc);
+    memc->p_dspin_m2p                  (signal_dspin_m2p_memc);
+    memc->p_dspin_clack                (signal_dspin_clack_memc);
 
     // wrapper MEMC