Index: branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 452)
+++ branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 453)
@@ -1438,6 +1438,6 @@
         {
           uint64_t flit = m_cc_receive_to_multi_ack_fifo.read();
-          updt_index    = DspinDhccpParam::dspin_get(flit,
-                            DspinDhccpParam::MULTI_ACK_UPDT_INDEX);
+          updt_index    = DspinOdccpParam::dspin_get(flit,
+                            DspinOdccpParam::MULTI_ACK_UPDT_INDEX);
 
           cc_receive_to_multi_ack_fifo_get = true;
@@ -4552,30 +4552,30 @@
       uint64_t flit = m_cc_receive_to_cleanup_fifo.read();
       uint32_t srcid =
-        DspinDhccpParam::dspin_get(
+        DspinOdccpParam::dspin_get(
             flit,
-            DspinDhccpParam::CLEANUP_SRCID);
+            DspinOdccpParam::CLEANUP_SRCID);
 
       uint8_t type =
-        DspinDhccpParam::dspin_get(
+        DspinOdccpParam::dspin_get(
             flit,
-            DspinDhccpParam::FROM_L1_TYPE);
+            DspinOdccpParam::FROM_L1_TYPE);
 
       r_cleanup_way_index =
-        DspinDhccpParam::dspin_get(
+        DspinOdccpParam::dspin_get(
             flit,
-            DspinDhccpParam::CLEANUP_WAY_INDEX);
+            DspinOdccpParam::CLEANUP_WAY_INDEX);
 
       r_cleanup_nline =
-        DspinDhccpParam::dspin_get(
+        DspinOdccpParam::dspin_get(
             flit,
-            DspinDhccpParam::CLEANUP_NLINE_MSB) << 32;
+            DspinOdccpParam::CLEANUP_NLINE_MSB) << 32;
 
       /*ODCCP*/ // Cleanup on no coherent line if 1
       r_cleanup_ncc = 
-        DspinDhccpParam::dspin_get(
+        DspinOdccpParam::dspin_get(
             flit, 
-            DspinDhccpParam::CLEANUP_NCC);
-
-      r_cleanup_inst  = (type == DspinDhccpParam::TYPE_CLEANUP_INST);
+            DspinOdccpParam::CLEANUP_NCC);
+
+      r_cleanup_inst  = (type == DspinOdccpParam::TYPE_CLEANUP_INST);
       r_cleanup_srcid = srcid;
 
@@ -4599,5 +4599,5 @@
           << " CLEANUP_IDLE> Cleanup request:" << std::hex
           << " / owner_id = "   << srcid
-          << " / owner_ins = "  << (type == DspinDhccpParam::TYPE_CLEANUP_INST) << std::endl;
+          << " / owner_ins = "  << (type == DspinOdccpParam::TYPE_CLEANUP_INST) << std::endl;
 #endif
       break;
@@ -4613,7 +4613,7 @@
 
       addr_t nline = r_cleanup_nline.read() |
-        DspinDhccpParam::dspin_get(flit, DspinDhccpParam::CLEANUP_NLINE_LSB);
+        DspinOdccpParam::dspin_get(flit, DspinOdccpParam::CLEANUP_NLINE_LSB);
       
-      bool eop = DspinDhccpParam::dspin_get(flit, DspinDhccpParam::FROM_L1_EOP);
+      bool eop = DspinOdccpParam::dspin_get(flit, DspinOdccpParam::FROM_L1_EOP);
       
       /*ODCCP*/ // if not eop (more than 2 flits) there is a cleanup no coherent with data
@@ -4652,5 +4652,5 @@
 
       uint32_t data = 
-        DspinDhccpParam::dspin_get (flit, DspinDhccpParam::CLEANUP_DATA_UPDT);
+        DspinOdccpParam::dspin_get (flit, DspinOdccpParam::CLEANUP_DATA_UPDT);
 
       r_cleanup_data[r_cleanup_data_index.read()] = data;
@@ -6982,10 +6982,10 @@
 
         uint8_t type =
-          DspinDhccpParam::dspin_get(
+          DspinOdccpParam::dspin_get(
               p_dspin_in.data.read(),
-              DspinDhccpParam::FROM_L1_TYPE);
-
-        if((type == DspinDhccpParam::TYPE_CLEANUP_DATA) or
-           (type == DspinDhccpParam::TYPE_CLEANUP_INST))
+              DspinOdccpParam::FROM_L1_TYPE);
+
+        if((type == DspinOdccpParam::TYPE_CLEANUP_DATA) or
+           (type == DspinOdccpParam::TYPE_CLEANUP_INST))
         {
           r_cc_receive_fsm = CC_RECEIVE_CLEANUP;
@@ -6993,5 +6993,5 @@
         }
 
-        if(type == DspinDhccpParam::TYPE_MULTI_ACK)
+        if(type == DspinOdccpParam::TYPE_MULTI_ACK)
         {
           r_cc_receive_fsm = CC_RECEIVE_MULTI_ACK;
@@ -8713,30 +8713,30 @@
         if(m_config_to_cc_send_inst_fifo.read())
         {
-          multi_inval_type = DspinDhccpParam::TYPE_MULTI_INVAL_INST;
+          multi_inval_type = DspinOdccpParam::TYPE_MULTI_INVAL_INST;
         }
         else
         {
-          multi_inval_type = DspinDhccpParam::TYPE_MULTI_INVAL_DATA;
+          multi_inval_type = DspinOdccpParam::TYPE_MULTI_INVAL_DATA;
         }
 
         uint64_t flit = 0;
         uint64_t dest = m_config_to_cc_send_srcid_fifo.read() <<
-                        (DspinDhccpParam::SRCID_WIDTH - vci_param_int::S);
-
-        DspinDhccpParam::dspin_set( flit,
+                        (DspinOdccpParam::SRCID_WIDTH - vci_param_int::S);
+
+        DspinOdccpParam::dspin_set( flit,
                                     dest,
-                                    DspinDhccpParam::MULTI_INVAL_DEST);
-
-        DspinDhccpParam::dspin_set( flit,
+                                    DspinOdccpParam::MULTI_INVAL_DEST);
+
+        DspinOdccpParam::dspin_set( flit,
                                     m_cc_global_id,
-                                    DspinDhccpParam::MULTI_INVAL_SRCID);
-
-        DspinDhccpParam::dspin_set( flit,
+                                    DspinOdccpParam::MULTI_INVAL_SRCID);
+
+        DspinOdccpParam::dspin_set( flit,
                                     r_config_to_cc_send_trdid.read(),
-                                    DspinDhccpParam::MULTI_INVAL_UPDT_INDEX);
-
-        DspinDhccpParam::dspin_set( flit,
+                                    DspinOdccpParam::MULTI_INVAL_UPDT_INDEX);
+
+        DspinOdccpParam::dspin_set( flit,
                                     multi_inval_type,
-                                    DspinDhccpParam::FROM_MC_TYPE);
+                                    DspinOdccpParam::FROM_MC_TYPE);
         p_dspin_out.write = true;
         p_dspin_out.data  = flit;
@@ -8747,7 +8747,7 @@
     {
         uint64_t flit = 0;
-        DspinDhccpParam::dspin_set( flit,
+        DspinOdccpParam::dspin_set( flit,
                                     r_config_to_cc_send_nline.read(),
-                                    DspinDhccpParam::MULTI_INVAL_NLINE);
+                                    DspinOdccpParam::MULTI_INVAL_NLINE);
         p_dspin_out.eop   = true;
         p_dspin_out.write = true;
@@ -8761,9 +8761,9 @@
         if(r_cleanup_to_cc_send_inst.read())
         {
-          cleanup_ack_type = DspinDhccpParam::TYPE_CLEANUP_ACK_INST;
+          cleanup_ack_type = DspinOdccpParam::TYPE_CLEANUP_ACK_INST;
         }
         else
         {
-          cleanup_ack_type = DspinDhccpParam::TYPE_CLEANUP_ACK_DATA;
+          cleanup_ack_type = DspinOdccpParam::TYPE_CLEANUP_ACK_DATA;
         }
 
@@ -8771,25 +8771,25 @@
         uint64_t dest =
           r_cleanup_to_cc_send_srcid.read() <<
-          (DspinDhccpParam::SRCID_WIDTH - vci_param_int::S);
-
-        DspinDhccpParam::dspin_set(
+          (DspinOdccpParam::SRCID_WIDTH - vci_param_int::S);
+
+        DspinOdccpParam::dspin_set(
             flit,
             dest,
-            DspinDhccpParam::CLEANUP_ACK_DEST);
-
-        DspinDhccpParam::dspin_set(
+            DspinOdccpParam::CLEANUP_ACK_DEST);
+
+        DspinOdccpParam::dspin_set(
             flit,
             r_cleanup_to_cc_send_set_index.read(),
-            DspinDhccpParam::CLEANUP_ACK_SET);
-
-        DspinDhccpParam::dspin_set(
+            DspinOdccpParam::CLEANUP_ACK_SET);
+
+        DspinOdccpParam::dspin_set(
             flit,
             r_cleanup_to_cc_send_way_index.read(),
-            DspinDhccpParam::CLEANUP_ACK_WAY);
-
-        DspinDhccpParam::dspin_set(
+            DspinOdccpParam::CLEANUP_ACK_WAY);
+
+        DspinOdccpParam::dspin_set(
             flit,
             cleanup_ack_type,
-            DspinDhccpParam::FROM_MC_TYPE);
+            DspinOdccpParam::FROM_MC_TYPE);
 
         p_dspin_out.eop   = true;
@@ -8808,30 +8808,30 @@
         if(m_xram_rsp_to_cc_send_inst_fifo.read())
         {
-          multi_inval_type = DspinDhccpParam::TYPE_MULTI_INVAL_INST;
+          multi_inval_type = DspinOdccpParam::TYPE_MULTI_INVAL_INST;
         }
         else
         {
-          multi_inval_type = DspinDhccpParam::TYPE_MULTI_INVAL_DATA;
+          multi_inval_type = DspinOdccpParam::TYPE_MULTI_INVAL_DATA;
         }
 
         uint64_t flit = 0;
         uint64_t dest = m_xram_rsp_to_cc_send_srcid_fifo.read() <<
-                        (DspinDhccpParam::SRCID_WIDTH - vci_param_int::S);
-
-        DspinDhccpParam::dspin_set( flit,
+                        (DspinOdccpParam::SRCID_WIDTH - vci_param_int::S);
+
+        DspinOdccpParam::dspin_set( flit,
                                     dest,
-                                    DspinDhccpParam::MULTI_INVAL_DEST);
-
-        DspinDhccpParam::dspin_set( flit,
+                                    DspinOdccpParam::MULTI_INVAL_DEST);
+
+        DspinOdccpParam::dspin_set( flit,
                                     m_cc_global_id,
-                                    DspinDhccpParam::MULTI_INVAL_SRCID);
-
-        DspinDhccpParam::dspin_set( flit,
+                                    DspinOdccpParam::MULTI_INVAL_SRCID);
+
+        DspinOdccpParam::dspin_set( flit,
                                     r_xram_rsp_to_cc_send_trdid.read(),
-                                    DspinDhccpParam::MULTI_INVAL_UPDT_INDEX);
-
-        DspinDhccpParam::dspin_set( flit,
+                                    DspinOdccpParam::MULTI_INVAL_UPDT_INDEX);
+
+        DspinOdccpParam::dspin_set( flit,
                                     multi_inval_type,
-                                    DspinDhccpParam::FROM_MC_TYPE);
+                                    DspinOdccpParam::FROM_MC_TYPE);
         p_dspin_out.write = true;
         p_dspin_out.data  = flit;
@@ -8844,7 +8844,7 @@
         uint64_t flit = 0;
 
-        DspinDhccpParam::dspin_set( flit,
+        DspinOdccpParam::dspin_set( flit,
                                     r_xram_rsp_to_cc_send_nline.read(),
-                                    DspinDhccpParam::MULTI_INVAL_NLINE);
+                                    DspinOdccpParam::MULTI_INVAL_NLINE);
         p_dspin_out.eop   = true;
         p_dspin_out.write = true;
@@ -8861,15 +8861,15 @@
         uint64_t flit = 0;
 
-        DspinDhccpParam::dspin_set( flit,
+        DspinOdccpParam::dspin_set( flit,
                                     m_broadcast_boundaries,
-                                    DspinDhccpParam::BROADCAST_BOX);
-
-        DspinDhccpParam::dspin_set( flit,
+                                    DspinOdccpParam::BROADCAST_BOX);
+
+        DspinOdccpParam::dspin_set( flit,
                                     m_cc_global_id,
-                                    DspinDhccpParam::BROADCAST_SRCID);
-
-        DspinDhccpParam::dspin_set( flit,
+                                    DspinOdccpParam::BROADCAST_SRCID);
+
+        DspinOdccpParam::dspin_set( flit,
                                     1ULL,
-                                    DspinDhccpParam::FROM_MC_BC);
+                                    DspinOdccpParam::FROM_MC_BC);
         p_dspin_out.write = true;
         p_dspin_out.data  = flit;
@@ -8880,7 +8880,7 @@
     {
         uint64_t flit = 0;
-        DspinDhccpParam::dspin_set( flit,
+        DspinOdccpParam::dspin_set( flit,
                                     r_xram_rsp_to_cc_send_nline.read(),
-                                    DspinDhccpParam::BROADCAST_NLINE);
+                                    DspinOdccpParam::BROADCAST_NLINE);
         p_dspin_out.write = true;
         p_dspin_out.eop   = true;
@@ -8892,7 +8892,7 @@
     {
         uint64_t flit = 0;
-        DspinDhccpParam::dspin_set( flit,
+        DspinOdccpParam::dspin_set( flit,
                                     r_config_to_cc_send_nline.read(),
-                                    DspinDhccpParam::BROADCAST_NLINE);
+                                    DspinOdccpParam::BROADCAST_NLINE);
         p_dspin_out.write = true;
         p_dspin_out.eop   = true;
@@ -8904,7 +8904,7 @@
     {
         uint64_t flit = 0;
-        DspinDhccpParam::dspin_set( flit,
+        DspinOdccpParam::dspin_set( flit,
                                     r_write_to_cc_send_nline.read(),
-                                    DspinDhccpParam::BROADCAST_NLINE);
+                                    DspinOdccpParam::BROADCAST_NLINE);
         p_dspin_out.write = true;
         p_dspin_out.eop   = true;
@@ -8916,7 +8916,7 @@
     {
         uint64_t flit = 0;
-        DspinDhccpParam::dspin_set( flit,
+        DspinOdccpParam::dspin_set( flit,
                                     r_cas_to_cc_send_nline.read(),
-                                    DspinDhccpParam::BROADCAST_NLINE);
+                                    DspinOdccpParam::BROADCAST_NLINE);
         p_dspin_out.write = true;
         p_dspin_out.eop   = true;
@@ -8932,9 +8932,9 @@
         if(m_write_to_cc_send_inst_fifo.read())
         {
-          multi_updt_type = DspinDhccpParam::TYPE_MULTI_UPDT_INST;
+          multi_updt_type = DspinOdccpParam::TYPE_MULTI_UPDT_INST;
         }
         else
         {
-          multi_updt_type = DspinDhccpParam::TYPE_MULTI_UPDT_DATA;
+          multi_updt_type = DspinOdccpParam::TYPE_MULTI_UPDT_DATA;
         }
 
@@ -8942,25 +8942,25 @@
         uint64_t dest =
           m_write_to_cc_send_srcid_fifo.read() <<
-          (DspinDhccpParam::SRCID_WIDTH - vci_param_int::S);
-
-        DspinDhccpParam::dspin_set(
+          (DspinOdccpParam::SRCID_WIDTH - vci_param_int::S);
+
+        DspinOdccpParam::dspin_set(
             flit,
             dest,
-            DspinDhccpParam::MULTI_UPDT_DEST);
-
-        DspinDhccpParam::dspin_set(
+            DspinOdccpParam::MULTI_UPDT_DEST);
+
+        DspinOdccpParam::dspin_set(
             flit,
             m_cc_global_id,
-            DspinDhccpParam::MULTI_UPDT_SRCID);
-
-        DspinDhccpParam::dspin_set(
+            DspinOdccpParam::MULTI_UPDT_SRCID);
+
+        DspinOdccpParam::dspin_set(
             flit,
             r_write_to_cc_send_trdid.read(),
-            DspinDhccpParam::MULTI_UPDT_UPDT_INDEX);
-
-        DspinDhccpParam::dspin_set(
+            DspinOdccpParam::MULTI_UPDT_UPDT_INDEX);
+
+        DspinOdccpParam::dspin_set(
             flit,
             multi_updt_type,
-            DspinDhccpParam::FROM_MC_TYPE);
+            DspinOdccpParam::FROM_MC_TYPE);
 
         p_dspin_out.write = true;
@@ -8974,13 +8974,13 @@
         uint64_t flit = 0;
 
-        DspinDhccpParam::dspin_set(
+        DspinOdccpParam::dspin_set(
             flit,
             r_write_to_cc_send_index.read(),
-            DspinDhccpParam::MULTI_UPDT_WORD_INDEX);
-
-        DspinDhccpParam::dspin_set(
+            DspinOdccpParam::MULTI_UPDT_WORD_INDEX);
+
+        DspinOdccpParam::dspin_set(
             flit,
             r_write_to_cc_send_nline.read(),
-            DspinDhccpParam::MULTI_UPDT_NLINE);
+            DspinOdccpParam::MULTI_UPDT_NLINE);
 
         p_dspin_out.write = true;
@@ -9001,13 +9001,13 @@
         uint64_t flit = 0;
 
-        DspinDhccpParam::dspin_set(
+        DspinOdccpParam::dspin_set(
             flit,
             multi_updt_be,
-            DspinDhccpParam::MULTI_UPDT_BE);
-
-        DspinDhccpParam::dspin_set(
+            DspinOdccpParam::MULTI_UPDT_BE);
+
+        DspinOdccpParam::dspin_set(
             flit,
             multi_updt_data,
-            DspinDhccpParam::MULTI_UPDT_DATA);
+            DspinOdccpParam::MULTI_UPDT_DATA);
 
         p_dspin_out.write = true;
@@ -9025,9 +9025,9 @@
         if(m_cas_to_cc_send_inst_fifo.read())
         {
-          multi_updt_type = DspinDhccpParam::TYPE_MULTI_UPDT_INST;
+          multi_updt_type = DspinOdccpParam::TYPE_MULTI_UPDT_INST;
         }
         else
         {
-          multi_updt_type = DspinDhccpParam::TYPE_MULTI_UPDT_DATA;
+          multi_updt_type = DspinOdccpParam::TYPE_MULTI_UPDT_DATA;
         }
 
@@ -9035,25 +9035,25 @@
         uint64_t dest =
           m_cas_to_cc_send_srcid_fifo.read() <<
-          (DspinDhccpParam::SRCID_WIDTH - vci_param_int::S);
-
-        DspinDhccpParam::dspin_set(
+          (DspinOdccpParam::SRCID_WIDTH - vci_param_int::S);
+
+        DspinOdccpParam::dspin_set(
             flit,
             dest,
-            DspinDhccpParam::MULTI_UPDT_DEST);
-
-        DspinDhccpParam::dspin_set(
+            DspinOdccpParam::MULTI_UPDT_DEST);
+
+        DspinOdccpParam::dspin_set(
             flit,
             m_cc_global_id,
-            DspinDhccpParam::MULTI_UPDT_SRCID);
-
-        DspinDhccpParam::dspin_set(
+            DspinOdccpParam::MULTI_UPDT_SRCID);
+
+        DspinOdccpParam::dspin_set(
             flit,
             r_cas_to_cc_send_trdid.read(),
-            DspinDhccpParam::MULTI_UPDT_UPDT_INDEX);
-
-        DspinDhccpParam::dspin_set(
+            DspinOdccpParam::MULTI_UPDT_UPDT_INDEX);
+
+        DspinOdccpParam::dspin_set(
             flit,
             multi_updt_type,
-            DspinDhccpParam::FROM_MC_TYPE);
+            DspinOdccpParam::FROM_MC_TYPE);
 
         p_dspin_out.write = true;
@@ -9067,13 +9067,13 @@
         uint64_t flit = 0;
 
-        DspinDhccpParam::dspin_set(
+        DspinOdccpParam::dspin_set(
             flit,
             r_cas_to_cc_send_index.read(),
-            DspinDhccpParam::MULTI_UPDT_WORD_INDEX);
-
-        DspinDhccpParam::dspin_set(
+            DspinOdccpParam::MULTI_UPDT_WORD_INDEX);
+
+        DspinOdccpParam::dspin_set(
             flit,
             r_cas_to_cc_send_nline.read(),
-            DspinDhccpParam::MULTI_UPDT_NLINE);
+            DspinOdccpParam::MULTI_UPDT_NLINE);
 
         p_dspin_out.write = true;
@@ -9087,13 +9087,13 @@
         uint64_t flit = 0;
 
-        DspinDhccpParam::dspin_set(
+        DspinOdccpParam::dspin_set(
             flit,
             0xF,
-            DspinDhccpParam::MULTI_UPDT_BE);
-
-        DspinDhccpParam::dspin_set(
+            DspinOdccpParam::MULTI_UPDT_BE);
+
+        DspinOdccpParam::dspin_set(
             flit,
             r_cas_to_cc_send_wdata.read(),
-            DspinDhccpParam::MULTI_UPDT_DATA);
+            DspinOdccpParam::MULTI_UPDT_DATA);
 
         p_dspin_out.write = true;
@@ -9108,13 +9108,13 @@
         uint64_t flit = 0;
 
-        DspinDhccpParam::dspin_set(
+        DspinOdccpParam::dspin_set(
             flit,
             0xF,
-            DspinDhccpParam::MULTI_UPDT_BE);
-
-        DspinDhccpParam::dspin_set(
+            DspinOdccpParam::MULTI_UPDT_BE);
+
+        DspinOdccpParam::dspin_set(
             flit,
             r_cas_to_cc_send_wdata_high.read(),
-            DspinDhccpParam::MULTI_UPDT_DATA);
+            DspinOdccpParam::MULTI_UPDT_DATA);
 
         p_dspin_out.write = true;